:- use_module(library(lists)).

% mondat(Alany, ll, L0, L): L0-L kielemezhet egy Alany alanybl s ll 
% lltmnybl ll mondatt. Alany lehet els vagy msodik szemly
% nvms, vagy egyetlen szbl ll (harmadik szemly) alany.
mondat(Alany, ll) --> {n_te(Alany, Ige)}, n_te_perm(Alany, Ige, ll).
mondat(Alany, ll) --> sz(Alany), szavak(ll).

% n_te(Alany, Ige): 
% Az Alany els/msodik szemly nvmsnak megfelel ltige az Ige.
n_te("n", "vagyok").
n_te("te", "vagy").

% n_te_perm(Ki, Ige, ll, L0, L): L0-L kielemezhet egy Ki
% nvmsbl, Ige igealakbl s ll lltmnybl ll mondatt. 
n_te_perm(Alany, Ige, ll)  --> sz(Alany), sz(Ige), szavak(ll).
n_te_perm(Alany, Ige, ll)  --> sz(Alany), szavak(ll), sz(Ige).
n_te_perm(Alany, Ige, ll)  --> szavak(ll), sz(Ige), sz(Alany).
n_te_perm(_Alany, Ige, ll) --> szavak(ll), sz(Ige).

% sz(Sz, L0, L): L0-L egy Sz betsorozatbl ll (nem res) sz.
sz(Sz) --> bet(B), szmaradk(SzM), {illik([B|SzM], Sz)}, kz.

% szmaradk(Sz, L0, L): L0-L egy Sz betsorozatbl ll (esetleg res) sz.
szmaradk([B|Sz]) --> bet(B), !, szmaradk(Sz).
szmaradk([]) --> [].

% illik(Sz0, Sz): Sz0 = Sz, vagy a kezd kis-nagy betben klnbznek.
illik([B0|L], [B|L]) :-
	(   B = B0 -> true
	;   abs(B-B0) =:= 32
	).

% kz(L0, L): L0-L nulla, egy vagy tbb szkz.
kz --> " " -> kz ; [].

% bet(K, L0, L): L0-L egy K kd bet.
% Betnek szmt minden a " .?" jelektl klnbz karakter.
bet(K) --> [K], {non_member(K, " .?")}.

% szavak(SzL, L0, L): L0-L egy SzL sz-lista.
szavak([Sz|Szk]) --> sz(Sz), 
     (   szavak(Szk)
     ;   {Szk = []}
     ).

% menet(Monds, L0, L): Az L0-L kielemzett alakja Monds.
menet(krdez(Alany)) --> 
    {krd(Sz)}, mondat(Alany, [Sz]), "?".
menet(kijelent(Alany,ll)) --> 
    mondat(Alany, ll), ".".
menet(un) --> sz("unlak"), ".".

% krd(Sz): Sz egy krdsz.
krd("mi").   krd("ki").   krd("kicsoda").

% Egy prbeszdet valst meg.
prbeszd :-
     repeat, rd_line(L),
     (   menet(M, L, []) -> feldolgoz(M)
     ;   write('Nem rtem\n'), fail
     ), M = un, !.

:- dynamic tudom/2.

% feldolgoz(Monds): feldolgozza a felhasznltl rkez Monds zenetet.
feldolgoz(un) :- write('n is.\n').
feldolgoz(kijelent(Alany, ll)) :-
     assertz(tudom(Alany,ll)), write('Felfogtam.\n').
feldolgoz(krdez(Alany)) :-
     tudom(Alany, _), !, vlasz(Alany).
feldolgoz(krdez(_)) :-
     write('Nem tudom.\n').

% Felsorolja az Alany ismert tulajdonsgait.
vlasz(Alany) :- tudom(Alany, ll),
     (   member(Sz, ll), format('~s ', [Sz]), fail
     ;   nl, fail
     ).
vlasz(_).

% -------- Sorbeolvass ---------
% L a kvetkez sor karakterkdjainak listja.
rd_line(L):- peek_code(0'\n), !, get_code(_), L = [].
rd_line([C|L]) :- get_code(C), rd_line(L).

end_of_file.

| ?- prbeszd.
|: Ki vagyok n?
Nem tudom.
|: n nagyon okos vagyok.
Felfogtam.
|: Te egy Prolog program vagy.
Felfogtam.
|: n vagyok Jeromos.
Felfogtam.
|: Ki vagyok n?
nagyon okos 
Jeromos 
|: Ki vagy te?
egy Prolog program 
|: unlak.
n is.
yes
