% Formula: szmokbl s az `x' nvkonstansbl `+' s `*' opertorokkal
% felpl kifejezs
% :- type kif == {x} \/ number \/ {kif+kif} \/ {kif*kif}

% Lineris formula: olyan formula, amelyben a `*' opertor legalbb egyik
% oldaln szm ll.

% egyhat0(Kif, E): A Kif lineris formulban az x egytthatja E.
% Az eljrs nem teljesen helyes (tbbszrs megoldst ad),
% lsd az albbi 2. pldt.
egyhat0(x, 1).
egyhat0(Kif, E) :-
	number(Kif), E = 0.
egyhat0(K1+K2, E) :-
	egyhat0(K1, E1),
	egyhat0(K2, E2),
	E is E1+E2.
egyhat0(K1*K2, E) :-
	number(K1),
	egyhat0(K2, E0),
	E is K1*E0.
egyhat0(K1*K2, E) :-
	number(K2), 
	egyhat0(K1, E0),
	E is K2*E0.


% | ?- egyhat0(((x+1)*3)+x+2*(x+x+3), E).
% E = 8 ? ;
% no
% | ?- egyhat0(x+2*3, E).
% E = 1 ? ;
% E = 1 ? ;
% no

% egyhat(Kif, E): A Kif lineris formulban az x egytthatja E.
egyhat(x, 1).
egyhat(Kif, E) :-
	number(Kif), E = 0.
egyhat(K1+K2, E) :-
	egyhat(K1, E1),
	egyhat(K2, E2),
	E is E1+E2.
egyhat(K1*K2, E) :-
	(   number(K1),
	    egyhat(K2, E0),
	    E is K1*E0
	;   \+ number(K1),
	    number(K2), 
	    egyhat(K1, E0),
	    E is K2*E0
	).


% | ?- egyhat(x+2*3, E).
% E = 1 ? ;
% no


% egyhat1(Kif, E): A Kif lineris formulban az x egytthatja E.
% Ugyanaz, mint egyhat/2, csak feltteles diszjunktv szerkezetet hasznl.
egyhat1(x, 1).
egyhat1(Kif, E) :-
	number(Kif), E = 0.
egyhat1(K1+K2, E) :-
	egyhat1(K1, E1),
	egyhat1(K2, E2),
	E is E1+E2.
egyhat1(K1*K2, E) :-
	(   number(K1) ->
	    egyhat1(K2, E0),
	    E is K1*E0
	;   /* \+ number(K1), */
	    number(K2), 
	    egyhat1(K1, E0),
	    E is K2*E0
	).


