% Fa az X, Y, Z, U levelekbl ll
negylevelu(X, Y, Z, U, Fa) :-  
     flm(Fa0, Y, leaf(X)),
     flm(Fa1, Z, Fa0),
     flm(Fa, U, Fa1).

% flm(Fa, Ertek, Marad): A Fa sszetett binris fa egy Ertek rtk 
% levelnek elhagysa utn marad a Marad fa. (flm = fa_level_maradek)
flm(node(leaf(V),T), V, T).               % ha a bal rszfa a keresett levl
                                          % akkor a jobb rszfa a maradk
flm(node(T,leaf(V)), V, T).               % ugyanez jobboldali levl esetre
flm(node(L0,R), V, node(L,R)) :-
        flm(L0, V, L).                    % ha a bal rszfbl elhagyhat a levl
                                          % akkor ennek maradka, kiegsztve 
                                          % a jobb rszfval, lesz a teljes fa maradka
flm(node(L,R0), V, node(L,R1)) :-
        flm(R0, V, R1).                   % ugyanez jobb rszfa esetre

% fa_kif(Fa, Kif): Kif a Fa faval azonos alak, azonos szmokbl ll
% aritmetikai kifejezs, amelyben a ngy alapmvelet fordulhat el.
fa_kif(leaf(V), V).
fa_kif(node(L,R), Exp) :-
	fa_kif(L, E1),
	fa_kif(R, E2),
	alap4(E1, E2, Exp).

% alap4(X, Y, Kif): Kif az X s Y kifejezsekbl a ngy alapmvelet egyikvel ll el.
alap4(X, Y, X+Y).
alap4(X, Y, X-Y).
alap4(X, Y, X*Y).
alap4(X, Y, X/Y).

% Kif egy a ngy alapmvelettel az X, Y, Z, U szmokbl
% felptett kifejezs, amelynek rtke Ertek.
negylevelu_erteke(X, Y, Z, U, Ertek, Kif) :-
	negylevelu(X, Y, Z, U, Fa),
	fa_kif(Fa, Kif),
	Kif =:= Ertek.




% faki(Fa): Fa kirhat (mindig teljesl :-). Mellkhatsknt kirja a Fa ft.
faki(leaf(V)) :- 
        write(@), write(V).    % A write(X) beptett pred. kirja az X kifejezst.
faki(node(L,R)) :-
        write('('), faki(L), write(' -- '), faki(R), write(')').

mindent_ki :-
	negylevelu(1, 3, 4, 6, Fa),
	fa_kif(Fa, Kif),
	faki(Fa), write('   '), write(Kif), nl,
	fail.
