:- op(500, xfx, --).
:- op(450, fx, @).

% :- type tree6 == @integer \/ {tree6--tree6}.

sum_tree6(Tree, Sum) :-
	sum_tree6(Tree, 0, Sum).

sum_tree6(@Tree, Sum0, Sum) :-
	integer(Tree), Sum is Sum0+Tree.
sum_tree6(Left--Right, Sum0, Sum) :-
	sum_tree6(Left, Sum0, Sum1),
	sum_tree6(Right, Sum1, Sum).

% ?- sum_tree6(@5--(@3-- @2), Sum).

:- use_module(library(lists)).

% leaves(Tree, Leaves): Tree leveleinek listja Leaves.
leaves(@Int, [Int]).
leaves(Left--Right, L) :-
	leaves(Left, L1),
	leaves(Right, L2),
	append(L1, L2, L).

% leaves2(Tree, Leaves): Tree leveleinek listja Leaves.
leaves2(Tree, L) :-
	leaves2(Tree, [], L).

% leaves2(Tree, L0, L): Tree leveleinek listjt L0 el fzve kapjuk az L listt.
leaves2(@Int, L0, [Int|L0]).
leaves2(Left--Right, L0, L) :-
	leaves2(Right, L0, L1),
	leaves2(Left, L1, L).

% Az L szmlista sszege S.
sum_list1(L, S) :-
	sum_list1(L, 0, S).

% sum_list1(+L, +S0, -S): Az L szmlista sszege S0-hoz adva S-t ad.
%                        Az L szmlista sszege S-S0.
sum_list1([], S0, S0).
sum_list1([X|L], S0, S) :-
	S1 is S0+X,
	sum_list1(L, S1, S).
